<template>
    <b-card header="Setup chart" class="chart-form">
        <b-card-body>
            <b-form @submit="onSubmit">
                <b-form-group id="input-group-format" label="Format:" label-for="input-format">
                    <b-form-select
                            id="input-format"
                            v-model="form.format"
                            :options="formats"
                            required
                    ></b-form-select>
                </b-form-group>

                <b-form-group id="input-group-mark" label="Mark:" label-for="input-mark">
                    <b-form-select
                            id="input-mark"
                            v-model="form.mark"
                            :options="marks"
                            required
                    ></b-form-select>
                </b-form-group>

                <b-form-group
                        v-for="(item, key) in form.encoding"
                        v-bind:key="key"
                        label-cols="2"
                        :label="key">
                    <b-form-row>
                        <b-col cols="1">
                            <b-checkbox
                                    v-model="item.used"></b-checkbox>
                        </b-col>
                        <b-col cols="7">
                            <b-input
                                    type="text"
                                    placeholder="Field name"
                                    v-model="item.value"></b-input>
                        </b-col>
                        <b-col  cols="4">
                            <b-select id="input-mark"
                                      v-model="item.dataType"
                                      :options="encodingFieldDataTypes">
                            </b-select>
                        </b-col>
                    </b-form-row>
                </b-form-group>

                <b-form-group
                        id="input-group-encoding-tooltip"
                        label="Tooltip fields:">
                    <b-form-tags
                            input-id="input-tooltip-tags"
                            v-model="form.tooltip"></b-form-tags>
                </b-form-group>

                <b-form-group
                        id="input-group-data-json"
                        label="Input data JSON:">
                    <b-form-textarea
                            id="input-data-json"
                            placeholder="Input data in JSON format"
                            rows="8"
                            v-model="form.data"></b-form-textarea>
                </b-form-group>

                <b-button type="submit" variant="primary" class="mr-1 float-right">Submit</b-button>
                <b-button type="reset" variant="danger" class="mr-1 float-right">Reset</b-button>
            </b-form>
        </b-card-body>
    </b-card>
</template>

<script>
    export default {
        name: "ChartForm",
        data() {
            return {
                form: {
                    format: 'png',
                    mark: '',
                    tooltip: [],
                    encoding: {
                        x: {value: '', dataType: '', used: false},
                        y: {value: '', dataType: '', used: false},
                        x2: {value: '', dataType: '', used: false},
                        y2: {value: '', dataType: '', used: false},
                        longitude: {value: '', dataType: '', used: false},
                        latitude: {value: '', dataType: '', used: false},
                        longitude2: {value: '', dataType: '', used: false},
                        latitude2: {value: '', dataType: '', used: false},
                        xError: {value: '', dataType: '', used: false},
                        yError: {value: '', dataType: '', used: false},
                        xError2: {value: '', dataType: '', used: false},
                        yError2: {value: '', dataType: '', used: false},
                    },
                    data: '',
                },
                visibleEncodingFields: [],

                formats: [
                    {value: 'png', text: 'PNG Image'},
                    {value: 'html', text: 'HTML'},
                    {value: 'svg', text: 'SVG (Scalable Vector Graphics)'}
                ],
                // TODO: change bare values to value with description
                marks: ['area', 'bar', 'circle', 'geoshape', 'image', 'line', 'point', 'rect', 'rule', 'square', 'text', 'tick'],
                showChart: false,
                encodingFieldDataTypes: [
                    {value: '', text: 'Default'},
                    {value: 'quantitative', text: 'Quantitative'},
                    {value: 'ordinal', text: 'Ordinal'},
                    {value: 'nominal', text: 'Nominal'},
                    {value: 'temporal', text: 'Temporal'},
                    {value: 'geojson', text: 'Geojson'},
                ]
            }
        },
        methods: {
            onSubmit(evt) {
                evt.preventDefault()

                var form = this.form;

                var encoding = {};

                if (form.tooltip.length > 0)
                {
                    encoding['tooltip'] = form.tooltip;
                }

                for(const prop in form.encoding)
                {
                    const entry = form.encoding[prop];

                    if (entry.used && entry.value.trim() !== '') {
                        var value = {
                            field: entry.value.trim()
                        };
                        if (entry.dataType !== '')
                        {
                            value['type'] = entry.dataType;
                        }

                        encoding[prop] = value;
                    }
                }

                var outputData = {
                    format: form.format,
                    vega: {
                        $schema: "https://vega.github.io/schema/vega-lite/v4.json",
                        data: {
                            values: JSON.parse(form.data)
                        },
                        encoding: encoding,
                        mark: form.mark,
                    },
                }

                this.$emit('formFinished', outputData);
                window.scrollTo(0, 0);
            }
        }
    }
</script>

<style scoped>

</style>